/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import com.ibm.etools.c.CBehavioralFeature;
import com.ibm.etools.c.CClassifier;
import com.ibm.etools.c.CDerived;
import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.CParameter;
import com.ibm.etools.c.CSourceText;
import com.ibm.etools.c.datatypes.CDirectionKind;
import com.ibm.etools.tdlang.TDLangClassifier;
import com.ibm.etools.tdlang.TDLangPackage;
import com.ibm.etools.typedescriptor.InstanceTDBase;
import com.ibm.etools.typedescriptor.TypeDescriptorPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Parameter</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link com.ibm.etools.c.impl.CParameterImpl#getDirection <em>Direction</em>}
 * </li>
 * <li>
 * {@link com.ibm.etools.c.impl.CParameterImpl#getBehavioralFeature <em>Behavioral Feature</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class CParameterImpl extends CTypedElementImpl implements CParameter {
    /**
     * The default value of the '{@link #getDirection() <em>Direction</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getDirection()
     * @generated @ordered
     */
    protected static final CDirectionKind DIRECTION_EDEFAULT = CDirectionKind.PARAMETER_LITERAL;

    /**
     * The cached value of the '{@link #getDirection() <em>Direction</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getDirection()
     * @generated @ordered
     */
    protected CDirectionKind direction = DIRECTION_EDEFAULT;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CParameterImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return CPackage.eINSTANCE.getCParameter();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CDirectionKind getDirection() {
        return direction;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setDirection(CDirectionKind newDirection) {
        CDirectionKind oldDirection = direction;
        direction = newDirection == null ? DIRECTION_EDEFAULT : newDirection;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CPackage.CPARAMETER__DIRECTION, oldDirection, direction));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CBehavioralFeature getBehavioralFeature() {
        if (eContainerFeatureID != CPackage.CPARAMETER__BEHAVIORAL_FEATURE)
            return null;
        return (CBehavioralFeature) eContainer;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setBehavioralFeature(CBehavioralFeature newBehavioralFeature) {
        if (newBehavioralFeature != eContainer || (eContainerFeatureID != CPackage.CPARAMETER__BEHAVIORAL_FEATURE && newBehavioralFeature != null)) {
            if (EcoreUtil.isAncestor(this, newBehavioralFeature))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eContainer != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newBehavioralFeature != null)
                msgs = ((InternalEObject) newBehavioralFeature).eInverseAdd(this, CPackage.CBEHAVIORAL_FEATURE__PARAMETER, CBehavioralFeature.class, msgs);
            msgs = eBasicSetContainer((InternalEObject) newBehavioralFeature, CPackage.CPARAMETER__BEHAVIORAL_FEATURE, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CPackage.CPARAMETER__BEHAVIORAL_FEATURE, newBehavioralFeature, newBehavioralFeature));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CPARAMETER__TD_LANG_SHARED_TYPE:
                if (tdLangSharedType != null)
                    msgs = ((InternalEObject) tdLangSharedType).eInverseRemove(this, TDLangPackage.TD_LANG_CLASSIFIER__TD_LANG_TYPED_ELEMENT, TDLangClassifier.class, msgs);
                return basicSetTdLangSharedType((TDLangClassifier) otherEnd, msgs);
            case CPackage.CPARAMETER__INSTANCE_TD_BASE:
                if (instanceTDBase != null)
                    msgs = ((InternalEObject) instanceTDBase).eInverseRemove(this, TypeDescriptorPackage.INSTANCE_TD_BASE__LANGUAGE_INSTANCE, InstanceTDBase.class, msgs);
                return basicSetInstanceTDBase((InstanceTDBase) otherEnd, msgs);
            case CPackage.CPARAMETER__CONTAINS:
                if (contains != null)
                    msgs = ((InternalEObject) contains).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CPackage.CPARAMETER__CONTAINS, null, msgs);
                return basicSetContains((CDerived) otherEnd, msgs);
            case CPackage.CPARAMETER__BEHAVIORAL_FEATURE:
                if (eContainer != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return eBasicSetContainer(otherEnd, CPackage.CPARAMETER__BEHAVIORAL_FEATURE, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CPARAMETER__TD_LANG_SHARED_TYPE:
                return basicSetTdLangSharedType(null, msgs);
            case CPackage.CPARAMETER__INSTANCE_TD_BASE:
                return basicUnsetInstanceTDBase(msgs);
            case CPackage.CPARAMETER__CONTAINS:
                return basicSetContains(null, msgs);
            case CPackage.CPARAMETER__BEHAVIORAL_FEATURE:
                return eBasicSetContainer(null, CPackage.CPARAMETER__BEHAVIORAL_FEATURE, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
        if (eContainerFeatureID >= 0) {
            switch (eContainerFeatureID) {
            case CPackage.CPARAMETER__BEHAVIORAL_FEATURE:
                return ((InternalEObject) eContainer).eInverseRemove(this, CPackage.CBEHAVIORAL_FEATURE__PARAMETER, CBehavioralFeature.class, msgs);
            default:
                return eDynamicBasicRemoveFromContainer(msgs);
            }
        }
        return ((InternalEObject) eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CPARAMETER__NAME:
            return getName();
        case CPackage.CPARAMETER__TD_LANG_SHARED_TYPE:
            if (resolve)
                return getTdLangSharedType();
            return basicGetTdLangSharedType();
        case CPackage.CPARAMETER__INSTANCE_TD_BASE:
            if (resolve)
                return getInstanceTDBase();
            return basicGetInstanceTDBase();
        case CPackage.CPARAMETER__TYPE:
            if (resolve)
                return getType();
            return basicGetType();
        case CPackage.CPARAMETER__CONTAINS:
            return getContains();
        case CPackage.CPARAMETER__SOURCE:
            if (resolve)
                return getSource();
            return basicGetSource();
        case CPackage.CPARAMETER__DIRECTION:
            return getDirection();
        case CPackage.CPARAMETER__BEHAVIORAL_FEATURE:
            return getBehavioralFeature();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CPARAMETER__NAME:
            setName((String) newValue);
            return;
        case CPackage.CPARAMETER__TD_LANG_SHARED_TYPE:
            setTdLangSharedType((TDLangClassifier) newValue);
            return;
        case CPackage.CPARAMETER__INSTANCE_TD_BASE:
            setInstanceTDBase((InstanceTDBase) newValue);
            return;
        case CPackage.CPARAMETER__TYPE:
            setType((CClassifier) newValue);
            return;
        case CPackage.CPARAMETER__CONTAINS:
            setContains((CDerived) newValue);
            return;
        case CPackage.CPARAMETER__SOURCE:
            setSource((CSourceText) newValue);
            return;
        case CPackage.CPARAMETER__DIRECTION:
            setDirection((CDirectionKind) newValue);
            return;
        case CPackage.CPARAMETER__BEHAVIORAL_FEATURE:
            setBehavioralFeature((CBehavioralFeature) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CPARAMETER__NAME:
            unsetName();
            return;
        case CPackage.CPARAMETER__TD_LANG_SHARED_TYPE:
            setTdLangSharedType((TDLangClassifier) null);
            return;
        case CPackage.CPARAMETER__INSTANCE_TD_BASE:
            unsetInstanceTDBase();
            return;
        case CPackage.CPARAMETER__TYPE:
            setType((CClassifier) null);
            return;
        case CPackage.CPARAMETER__CONTAINS:
            setContains((CDerived) null);
            return;
        case CPackage.CPARAMETER__SOURCE:
            setSource((CSourceText) null);
            return;
        case CPackage.CPARAMETER__DIRECTION:
            setDirection(DIRECTION_EDEFAULT);
            return;
        case CPackage.CPARAMETER__BEHAVIORAL_FEATURE:
            setBehavioralFeature((CBehavioralFeature) null);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CPARAMETER__NAME:
            return isSetName();
        case CPackage.CPARAMETER__TD_LANG_SHARED_TYPE:
            return tdLangSharedType != null;
        case CPackage.CPARAMETER__INSTANCE_TD_BASE:
            return isSetInstanceTDBase();
        case CPackage.CPARAMETER__TYPE:
            return type != null;
        case CPackage.CPARAMETER__CONTAINS:
            return contains != null;
        case CPackage.CPARAMETER__SOURCE:
            return source != null;
        case CPackage.CPARAMETER__DIRECTION:
            return direction != DIRECTION_EDEFAULT;
        case CPackage.CPARAMETER__BEHAVIORAL_FEATURE:
            return getBehavioralFeature() != null;
        }
        return eDynamicIsSet(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String toString() {
        if (eIsProxy())
            return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (direction: ");
        result.append(direction);
        result.append(')');
        return result.toString();
    }

} //CParameterImpl
